package router_test

import (
	"encoding/json"
	"net/http"
	"net/http/httptest"
	"testing"

	"galaxy/model/rest"

	"galaxy/util"

	"galaxy/game/internal/controller"
	"galaxy/game/internal/router"
	"galaxy/game/internal/router/handler"

	"github.com/google/uuid"
	"github.com/stretchr/testify/assert"
)

func TestInit(t *testing.T) {
	root, cleanup := util.CreateWorkDir(t)
	defer cleanup()

	r := router.SetupRouter(handler.NewDefaultConfigExecutor(func(p *controller.Param) { p.StoragePath = root }))

	payload := generateInitRequest(10)

	w := httptest.NewRecorder()
	req, _ := http.NewRequest("POST", "/api/v1/admin/init", asBody(payload))
	r.ServeHTTP(w, req)

	assert.Equal(t, http.StatusCreated, w.Code, w.Body)
	var initResponse rest.StateResponse
	assert.NoError(t, json.Unmarshal(w.Body.Bytes(), &initResponse))
	assert.NoError(t, uuid.Validate(initResponse.ID.String()))
	assert.NotEqual(t, uuid.Nil, uuid.MustParse(initResponse.ID.String()))
}

func TestInitValidators(t *testing.T) {
	r := setupRouter()
	payload := generateInitRequest(9)

	w := httptest.NewRecorder()
	req, _ := http.NewRequest("POST", "/api/v1/admin/init", asBody(payload))
	r.ServeHTTP(w, req)

	assert.Equal(t, http.StatusBadRequest, w.Code, w.Body)
}
